<?php

namespace Lavalite\Test;

use User;

class Test
{
    /**
     * $slider object.
     */
    protected $slider;

    /**
     * Constructor.
     */
    public function __construct(\Lavalite\Test\Interfaces\SliderRepositoryInterface $slider)
    {
        $this->slider = $slider;
    }

    /**
     * Returns count of test.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.slider.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->slider->pushCriteria(new \Litepie\Lavalite\Repositories\Criteria\SliderUserCriteria());
        }

        $slider = $this->slider->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('test::' . $view, compact('slider'))->render();
    }
}
